
#include "main.h"
/*
// For discordant sibs
	while(i < max){

		// unaff. sib
		un1 = indiv2[0][i];							// allele 1 & 2 from unaffected
		un2 = indiv2[1][i];

		// aff. sib
		aff1 = indiv1[0][i];							// allele 1 & 2 from affected
		aff2 = indiv1[1][i];
		if(!((un1 == 255) || (un2 == 255) || (aff1 == 255) || (aff2 == 255))){	// make sure everything is typed
			storage.ns[i] += 1;						// increment # of sib pairs
			storage.xst[i][aff1] += 1;					// increment count for allele in affected
			storage.xst[i][aff2] += 1;					// ditto
			storage.xst[i][un1] -= 1;					// decrement count for allele in un-affected
			storage.xst[i][un2] -= 1;					// ditto
			storage.used[i][aff1]++;					// keep track of how many times allele was used
			storage.used[i][aff2]++;					
			storage.used[i][un1]++;
			storage.used[i][un2]++;

		}
		i++;
	}

// for triads
	while(i < max){
	
		// mother
		p1a1 = indiv1[0][i];
		p1a2 = indiv1[1][i];

		// father
		p2a1 = indiv2[0][i];
		p2a2 = indiv2[1][i];

		// for the aff. child
		cha1 = indiv3[0][i];
		cha2 = indiv3[1][i];


		if(((cha1 == p1a1) || (cha1 == p1a2)) && ((cha2 == p2a1) || (cha2 == p2a2))){	// we do this check to detect the very rare event when we have a crossover within a haplotype
			if(!((cha1 == 255) || (cha2 == 255) || (p1a1 == 255) || (p1a2 == 255) || (p2a1 == 255) || (p2a2 == 255))){ // we do not deal with missing genotypes
				storage.nt[i] += 1;
				storage.yst[i][cha1] += 2;
				storage.yst[i][cha2] += 2;
				storage.yst[i][p1a1] -= 1;
				storage.yst[i][p1a2] -= 1;
				storage.yst[i][p2a1] -= 1;
				storage.yst[i][p2a2] -= 1;
				storage.used[i][cha1]++;
				storage.used[i][cha2]++;
				storage.used[i][p1a1]++;
				storage.used[i][p1a2]++;
				storage.used[i][p2a1]++;
				storage.used[i][p2a2]++;
			}
		}
		i++;
	}

##########################################################
// sum all this mess up

	for(i = 0; i < max; i++){					// now we need to process the Ds into sum(D) & sum(D^2)
			for(j = 0; j < hfr->numall[i]; j++){		// hfr->numall[i] = essentially the number of alleles
				d = (float)storage.xst[i][j] + (float)storage.yst[i][j];
				storage.d[i][j] += d;
				storage.dsq[i][j] += (d * d);
			}
	} 

##########################################################
// get chisq & p-value

n = number of alleles
z-score = d / sqrt(dsq)
chisq = [(n-1) * sum_n(z-score * z_score)] / n

Then use :
cdfchi(&code, &p, &q, &global, &df, &status, &bound);		// from dcdflib.c, some old translation out of FORTRAN
to get p-value "p".

     void cdfchi(int *which,double *p,double *q,double *x,double *df,
            int *status,double *bound)

               Cumulative Distribution Function
               CHI-Square distribution


                              Function


     Calculates any one parameter of the chi-square
     distribution given values for the others.


                              Arguments


     WHICH --> Integer indicating which of the next three argument
               values is to be calculated from the others.
               Legal range: 1..3
               iwhich = 1 : Calculate P and Q from X and DF
               iwhich = 2 : Calculate X from P,Q and DF
               iwhich = 3 : Calculate DF from P,Q and X

     P <--> The integral from 0 to X of the chi-square
            distribution.
            Input range: [0, 1].

     Q <--> 1-P.
            Input range: (0, 1].
            P + Q = 1.0.

     X <--> Upper limit of integration of the non-central
            chi-square distribution.
            Input range: [0, +infinity).
            Search range: [0,1E300]

     DF <--> Degrees of freedom of the
             chi-square distribution.
             Input range: (0, +infinity).
             Search range: [ 1E-300, 1E300]

     STATUS <-- 0 if calculation completed correctly
               -I if input parameter number I is out of range
                1 if answer appears to be lower than lowest
                  search bound
                2 if answer appears to be higher than greatest
                  search bound
                3 if P + Q .ne. 1
               10 indicates error returned from cumgam.  See
                  references in cdfgam

     BOUND <-- Undefined if STATUS is 0

               Bound exceeded by parameter number I if STATUS
               is negative.

               Lower search bound if STATUS is 1.

               Upper search bound if STATUS is 2.


                              Method


     Formula    26.4.19   of Abramowitz  and     Stegun, Handbook  of
     Mathematical Functions   (1966) is used   to reduce the chisqure
     distribution to the incomplete distribution.

     Computation of other parameters involve a seach for a value that
     produces  the desired  value  of P.   The search relies  on  the
     monotinicity of P with the other parameter.

*/

// Helper struct to get threads started

struct Help_reader{
	Read_data reader_instance;
	char *infile;
	int loci;
	int line_size;
	int max_fam;
	int nmf;
};

struct Help_consumer{
	Consume_data consumer_instance;
	int num_threads;					// we need to know how many to start
	int id;								// thread id 1,...,cpus
	int num_loci;						// need to know so it can setup temp data structures
	int check;							// 0 = don't chack for missiing genotypes, 1 = do check
	struct Freq *fr;					// frequency struct 
	struct Freq *hfr;					// ...same for haplotypes
	int window;							// size of sliding window, 1 for regular PDT
	int opt;							// analysis option
	int genopdt;						// 0== regular PDT, 1 == genoPDT
	int verbose;						// decides if verbose output is used. Uses much more memory and is slower due to extra data collected
	int max_ped_size;					// maximum pedigree size
	int store_d;						// store d for permutation purpose? 0|1
	int pdtave;							// use PDT average stat 0|1
};

struct Help_pathway_thread{
	pathway_class pathway_instance;
	int num_threads;					// we need to know how many to start
	int id;
	int num_loci;
	int num_genes;
	int num_pathway;
	int num_pedigrees;
	int permutations;
	int verbose;
	// plus other info not yet determined
};

struct SNPinfo{
	int chrom;
	int position;
	int id;
};

// GLOBAL VARIABLES (I know it's ugly, but it an effecient way for interprocess/thread communication

struct Fam *families = NULL;					// need to declare those guys "extern" in class header files
struct Read_sync *read_synchronizer = NULL;
struct Result *result = NULL;
struct Freq *alfreq;									// freq[0], = # of loci, freq[1] = # of alleles @ locus1, ..., freq[n] = # of alleles @ locus n
struct Freq *hapalfreq;
char** rs_marker_names;
float **d_matrix;										// For permutation only. d_matrix[num_loci][num_pedigrees]	
HT hashtable;
char **pathway_names;
struct Gene *genearray;

// FUNCTION DECLARATIONS
int get_cpus();
int get_num_loci(char *infile, int &size, int nmf);
struct Freq * read_freq(char *infreq, int num_loci);
struct Freq * make_hpa_freq(int num_loci, int window, struct Freq *alfreq);
//		print_result(pdt2data->outfile_mrk, pdt2data->outfile_pval, printoption, num_loci, result, hapalfreq, check, window, genopdt, mrkhashlist, mrklistsize,verbose,tempf,pdt2data->permute);

//void print_result(char*, char*, int, int, struct Result *, int, struct Freq *alfreq, int check, int window, int genopdt, char **list, unsigned int list_size, int verbose, float *perm, int per);
//void print_result(struct Data*, int, int, struct Result *, struct Freq *alfreq, int check, int genopdt, char **list, unsigned int list_size, int verbose, float *perm);
struct Result* init_result(int num_loci, int max_fam_size, int cpus, struct Freq *, int check, int window, int verbose);
struct Result* init_result_geno(int num_loci, int max_fam_size, struct Freq *);
struct Fam* init_fam(int num_loci, int max_fam_size, int cpus, int naf);
struct Fam* delete_families(struct Fam*, int famsize, int fam_cnt);
struct Read_sync* init_sync(int num_loci, int max_fam_size, int cpus);
char** read_map_file(struct Freq*, int num_loci, char *filename);
unsigned int hash(char *buffer, unsigned int size);
int is_in_list(char **rslist, char *item, unsigned int list_size);
int findlargerprime(int start);
int findrank(float *list, int size, float item);		// assmues item is in list
int largerequal(float *list, int size, float item);		// finds number of values larger or equal

int getnumgenes(char *genefilename);
struct SNPinfo * getsnpinfo(int &snpsinmapfile, char *mapfile);
int** fillgindex(int &num_genes, struct SNPinfo *snplist, int snpsinmapfile, short *&s_index, int new_gene_file, int gene_buffer, char *gene_file_name, char *sindex_file_name, unsigned char *&genes_used);

int findfirstsnp(int chrom, int start, int size, struct SNPinfo *snplist);

struct Freq* allocate_Freq(int num_loci);
void* reader_thread_startup(void *);
void* consumer_thread_startup(void *);
char** read_mrklist(char* filename, unsigned int &mrklistsize);
int get_number_of_pedigrees(char* filename, int size);
float* permuter(int permutations, int peds, int snps);
void read_gene_file();
int** read_pathway_file(int &num_pathway, char *filename);
void read_simpleM_file();
void calculate_gene_scores();
void calculate_ES_scores(int);
void calculate_pdt_stats(int,int *);
void* pathway_thread_startup(void *);
void* random_thread_startup(void *);

void print_index();			// debug function to print p_index.dbg, g_index.dbg and s_index.dbg
void print_new_map_ped(char *mapfile, char *pedfile, int nmf, int size, int buffer, char *genefile, char *sindex_file, struct SNPinfo *snplist, unsigned char *genes_used);

int **p_index;				// pathway index, contains index of all genes in that pathway. Terminated with -1
int **g_index;				// gene index, contains index of all SNPs in that gene. May contain genes that are not listed in p_index. Terminated with -1
short *s_index;				// list of integers from the "s_index.txt" file corresponding to the genes in g_index
unsigned char *snpsused;	// a list of SNPs that are actually used. This means they fall into some gene that is in the gene_position_list file
double *pdt_stats;
int num_pathway;
int num_genes;
double *gene_score;
double *gene_score_id;
//unsigned short *ranking;
float *ES;
float **ES_P;
double **random_sets;
struct Sync_pathway *sync_pathway;
struct Sync_ran *sync_ran;
int *toll1;
int *toll2;
int *toll3;
float *max_perm;			// over all pathways for each permutation, ie. size is pdt2data->permutations

//******************************************



//**************** MAIN ********************
int main(int argc, char *argv[]){
	// First read the command line
	// <exe> <pedigree file> <# of loci> <max fam size> <outfile>
	// the .ped file:
	// <pedigree ID> <indiv. ID> <parent1/father> <parent2/mother> <sex> <aff. status> <a1, locus1> <a2, locus1> ... <a1, locus N> <a2, locus N>
	// Note that all entries in the .ped file are separated by 1 (ONE, UNO, EINS) white space. Why this restriction?
	// If you have a million entries you will have a million white spaces per line (i.e. 1 MB)...that's more than enough white space, don't ya think?
	
	char infile[100];
	char infreq[100];
	int num_loci;
	int max_fam_size;
	int rc;
	int i;
	int size;
	int nmf;							// Non Marker Fields, i.e. # of fields used to identify pedigree, individual ID, sex, aff. status, etc.

	if(argc != 2){
//		fprintf(stderr,"Useage: pdt2.exe <infile.ped> <infile.freq> <max_pedigree_size> <outfile> <non_marker_fields> #now optional parameters# <sliding windows size >=1> <use geno-PDT 0|1> <max CPUs> <options: 0=use all info; 1=triads only; 2=sibs only; 3=only triads if available>\n");
		fprintf(stderr,"Useage: pdt2 <PDT2 control file>\n");
		fprintf(stderr,"\n###\n%s###\n",reference);
		fprintf(stderr,"\n%s###\n",letterto);
		fprintf(stderr,"\n%s###\n",version);
		fprintf(stderr,"Example of PDT2 control file below:\n\n");
		fprintf(stderr,"%s",help);
		exit(0);
	}

	Readparam param_reader;
	struct Data* pdt2data = param_reader.master_reader(argv[1]);
	strcpy(infile, pdt2data->pedfile);
//	strcpy(infreq, argv[2]);
	// we need to know the size of the largest pedigree so we allocate just enough memory
	// Choosing this number too small will lead to a crash. Too big will waste precious memory.
	max_fam_size = pdt2data->maxfamsize;
	// we need to know what to print as result
	int printoption = pdt2data->printbymrk;
	nmf = pdt2data->nmf;
	// analysis window, usually 1
	int window = pdt2data->window;
	int verbose = pdt2data->verbose;
	int num_pedigrees = 0;
	int check = 1;
	// geno-PDT
	int genopdt = pdt2data->genopdt;
	if(genopdt == 1){
		window = 1;
	}
	// max CPUs
	int maxcpus = 32;
	if(pdt2data->max_cpus < maxcpus){
		maxcpus = pdt2data->max_cpus;
	}
	int cpus = get_cpus();
	if(cpus < 1){
	  cpus = 1;
	}
	if(cpus > maxcpus){
		cpus = maxcpus;
	}
	// analysis options
	int option = pdt2data->options;
	if((option < 0) || (option > 4)){
		option = 0;
	}
	/****************** read genefile **************************************/
	/*
	the genfile will look like this:
		PRKCZ 1 1981908 2116832
		PRKCZ 1 2036154 2116832
		PRKCZ 1 2005085 2116832
		USP48 1 22004793 22109688
		EPHB2 1 23037330 23241822
		PINK1 1 20959947 20978003
		EPHB2 1 23037330 23241822
		PUM1 1 31404352 31538564
	The main problems are:
	- one or more entries per gene with distinct ranges, like EPHB2.
	- same gene anem is not necessarily consecutive
	*/
	unsigned char *genes_used = NULL;

	int estimate;
	estimate = getnumgenes(pdt2data->genefile);
	hashtable.inittable((int)(1.25*estimate));
//	num_genes = insert_genes_in_htable(pdt2data->pathwayfile);
//	genearray = allocate_genearray(num_genes);
	int snpsinmapfile = 0;
	struct SNPinfo *snplist = getsnpinfo(snpsinmapfile, pdt2data->mapfile);
	s_index = NULL;
	g_index = fillgindex(num_genes, snplist, snpsinmapfile, s_index, pdt2data->printnew, pdt2data->genebuf, pdt2data->genefile, pdt2data->sindexfile, genes_used);
	if(pdt2data->printnew){
		print_new_map_ped(pdt2data->mapfile, pdt2data->pedfile, pdt2data->nmf, snpsinmapfile, pdt2data->genebuf, pdt2data->genefile, pdt2data->sindexfile, snplist, genes_used);
	}
	p_index = read_pathway_file(num_pathway, pdt2data->pathwayfile);
	num_loci = snpsinmapfile;
	print_index();				// prints s_index.dbg, g_index.dbg and p_index.dbg


#ifdef PROFILE
   PROFILE_START("main");
#endif
	/****************** read pathway information ***************************/

	cout<<"# of PATHWAYS: "<<num_pathway<<" # of GENES: "<<num_genes<<"\n";

	gene_score = new double[num_genes];
	gene_score_id = new double[num_genes];
	ES = new float[num_pathway];
	ES_P = new float*[num_pathway];

	for(i=0;i<num_pathway;i++) {
		ES_P[i] = new float[pdt2data->permutations +1];
	}

	toll1 = new int[num_pathway];
	toll2 = new int[num_pathway];
	toll3 = new int[num_pathway];
	memset((void*)toll1, 0, num_pathway*sizeof(int));
	memset((void*)toll2, 0, num_pathway*sizeof(int));
	memset((void*)toll3, 0, num_pathway*sizeof(int));

	pdt2data->permute = pdt2data->permutations;
	// should we only print out markers that are listed in "special_mrk_list:"?
	// see the PDT2 control file or param.h for details
	// Sometimes it is a pain to look through all 1 million markers if you're only interested in a hand full.
	// you can put those rs-numbers into a special list and PDT2 will only print those markers.
	int specialmrk = pdt2data->usespecialmrk;
	char **mrkhashlist = NULL;								// this holds all the "special" markers in a hash list. If the marker is in the list we will print it, else not print it
	unsigned int mrklistsize = 0;
	if(specialmrk){
		mrkhashlist = read_mrklist(pdt2data->specialmrklist, mrklistsize);		
	}
	
	size = 4*num_loci + 1000;
	if(pdt2data->verbose)
		fprintf(stderr,"loci = %i, cpus = %i, size = %i\n",num_loci, cpus, size);

	families = init_fam(num_loci, max_fam_size, cpus, nmf);

	read_synchronizer = init_sync(num_loci, max_fam_size, cpus);	
	
	if(pdt2data->usefreqfile){
		alfreq = read_freq(pdt2data->freqfile, num_loci);			// only reads the number of alleles per marker
	}
	else if(pdt2data->usemapfile){
		alfreq = allocate_Freq(num_loci);
		rs_marker_names = read_map_file(alfreq, num_loci, pdt2data->mapfile);
	}
	else{
		fprintf(stderr,"main(). Must have either .freq or .map file to proceed. Bailing out.\n");
		exit(0);
	}

	hapalfreq = make_hpa_freq(num_loci, window, alfreq);

	if(genopdt == 0){								// regular PDT
		result = init_result(num_loci, max_fam_size, cpus, hapalfreq, check, window, verbose);
	}
	else if(genopdt == 1){
		result = init_result_geno(num_loci, max_fam_size, hapalfreq);
	}
	else{
		fprintf(stderr,"genopdt == %i, unkown option. Read instructions and try again.\n", genopdt);
		exit(0);
	}
	// ... in case we want to permute stuff
	if(pdt2data->permute){
		num_pedigrees = get_number_of_pedigrees(infile, 2*size);
		cout<<"Num of families: "<<num_pedigrees<<"\n";
		d_matrix = NULL;
		d_matrix = new float*[num_pedigrees];
		if(d_matrix == NULL){
			fprintf(stderr,"main:: memory allocation for d_matrix failed.\n");
			exit(0);
		}
		for(i = 0; i < num_pedigrees; i++){
			d_matrix[i] = NULL;
			d_matrix[i] = new float[num_loci];
			if(d_matrix[i] == NULL){
				fprintf(stderr,"main:: memory allocation for d_matrix[%i] failed.\n",i);
				exit(0);
			}
			memset((void*)d_matrix[i], 0, num_loci*sizeof(float));
		}
	}
	else{
		d_matrix = NULL;
	}

	/*************************** Start random number thread *********************/
	sync_ran = new Sync_ran;
	// initialize sync_ran to meaningful values. These mutex control access to the random numbers
	sync_ran->stop = 0;
	sync_ran->ready = 0;
	sync_ran->empty = maxranarrays;
	for(i = 0; i < maxranarrays; i++){
		sync_ran->list[i] = 0;
	}
	int tc = pthread_mutex_init(&sync_ran->sync_random_mutex, NULL);
	if(tc){
		fprintf(stderr, "main::Failed to initialize sync_ran->sync_random_mutex. Bailing out.\n");
		exit(0);
	}
	tc = pthread_cond_init(&sync_ran->cond_waiting_consumer, NULL);
	if(tc){
		fprintf(stderr, "main::Failed to initialize sync_ran->cond_waiting_consumer. Bailing out.\n");
		exit(0);
	}
	tc = pthread_cond_init(&sync_ran->cond_waiting_producer, NULL);
	if(tc){
		fprintf(stderr, "main::Failed to initialize sync_ran->cond_waiting_producer. Bailing out.\n");
		exit(0);
	}
	pthread_t rannum_t;
	Help_random *arg4;
	arg4 = new Help_random;
	arg4->seed = 0;										// zero will do for now as a seed
	rc = pthread_create(&rannum_t, NULL, random_thread_startup, (void *)arg4);
	if(rc){
		fprintf(stderr,"main::Failed to create random thread. Bailing out\n");
		exit(0);
	}

	/*********************** end random number thread *******************/
	// start single reader thread
	pthread_t reader;					// the single reader/producer thread
	Help_reader *arg1;
	arg1 = new Help_reader;
	arg1->infile = pdt2data->pedfile;
	arg1->loci = num_loci;
	arg1->line_size = size;
	arg1->max_fam = max_fam_size;
	arg1->nmf = nmf;

	rc = pthread_create(&reader, NULL, reader_thread_startup, (void *) arg1);
	if(rc){
		fprintf(stderr,"Failed to create reader thread. Bailing out.");
		exit(0);
	}

// start several consumer threads
	pthread_t *consumer;
	consumer = new pthread_t[cpus];
	Help_consumer *arg2;
	arg2 = new Help_consumer[cpus];
	for(i = 0; i < cpus; i++){
		arg2[i].num_loci = num_loci;
		arg2[i].num_threads = cpus;
		arg2[i].id = i + 1;
		arg2[i].check = check;
		arg2[i].verbose = verbose;
		arg2[i].fr = alfreq;					// these are the frequencies, its read-only so we don't need any thread sync
		arg2[i].hfr = hapalfreq;
		arg2[i].window = window;
		arg2[i].opt = option;
		arg2[i].genopdt = genopdt;
		arg2[i].max_ped_size = max_fam_size;
		arg2[i].pdtave = pdt2data->pdtave;
		if(pdt2data->permute){
			arg2[i].store_d = 1;
		}
		else{
			arg2[i].store_d = 0;
		}
		rc = pthread_create(&consumer[i], NULL, consumer_thread_startup, (void *)&arg2[i]);
		if(rc){
			fprintf(stderr,"Failed to create consumer_thread[%i]. Bailing out.\n", i);
			exit(0);
		}
	}

//fprintf(stderr,"main:Before 5\n");
	rc = pthread_join(reader, NULL);

	if(rc){
		fprintf(stderr,"Failed to join reader thread. Bailing out.\n");
		exit(0);
	}
	delete arg1;
	arg1 = NULL;

	//pdt_stats = new double[num_loci];
//fprintf(stderr,"main:Before 7\n");	
	for(i = 0; i < cpus; i++){
		rc = pthread_join(consumer[i], NULL);
		if(rc){
			fprintf(stderr,"Failed to join consumer_thread[%i]. Bailing out.\n", i);
			exit(0);
		}
	}
	delete [] arg2;
	arg2 = NULL;

// **********************************************

	families = delete_families(families, max_fam_size, 2 * cpus + 2);

	/************** start pathway thread *********************/
	sync_pathway = new struct Sync_pathway;
	rc = pthread_mutex_init(&sync_pathway->sync_pathway_mutex, NULL);
	sync_pathway->next_to_process = cpus;

	if(rc){
		fprintf(stderr,"main::Failed to initialize sync_apl->sync_apl_mutex. Bailing out.\n");
		exit(0);
	}

	pthread_t *thread_pathway;
	thread_pathway = new pthread_t[cpus];
	struct Help_pathway_thread *arg3;
	arg3 = new struct Help_pathway_thread[cpus];
	for(i = 0; i < cpus; i++){
		arg3[i].num_threads = cpus;
		arg3[i].id = i;
		arg3[i].num_loci = num_loci;
		arg3[i].num_genes = num_genes;
		arg3[i].num_pathway = num_pathway;
		arg3[i].num_pedigrees = num_pedigrees;
		arg3[i].verbose = verbose;
		arg3[i].permutations = pdt2data->permutations;
		rc = pthread_create(&thread_pathway[i], NULL, pathway_thread_startup, (void*)&arg3[i]);
		if(rc){
			fprintf(stderr,"main::Failed to start thread_apl[%i]. Bailing out.\n", i);
			exit(0);
		}
	}
	
// end "start pathway" threads

// now wait for the threads to exit
// first the pathway-threads
	for(i = 0; i < cpus; i++){
		rc = pthread_join(thread_pathway[i], NULL);
		if(rc){
			fprintf(stderr,"main::Failed to join thread_pathway[%i]. Bailing out.\n", i);
			exit(0);
		}
	}
	delete [] arg3;
	arg3 = NULL;

	// calculate sd //////
	// delete matrix with PDT-stats
	
	for(i = 0; i < num_pedigrees; i++){
		delete [] d_matrix[i];
	}
	delete [] d_matrix;
	d_matrix = NULL;
	//double *sES_P = new double[num_pathway];

	FILE *fp;
	fp = fopen("permutation_info_raw.txt","w");
	float mean,sd;
	int j,k;

	for(i=0;i<num_pathway;i++) {
		fprintf(fp,"%f ",ES[i]);
		for(j=0; j < pdt2data->permutations; j++) {
			fprintf(fp,"%f ",ES_P[i][j]);
		}
		fprintf(fp,"\n");
	}
	fclose(fp);

//######################## Now deal with some multiple test correction


//######################## end mutliple test correction
	if(verbose){
		printf("Normalizing permutation table\n");
	}
	float square, variance;
	for(i=0;i<num_pathway;i++) {
		mean = 0;
		square = 0;
		sd = 0;
		for(j=0; j < pdt2data->permutations; j++) {
			mean += ES_P[i][j];
			square += (ES_P[i][j] * ES_P[i][j]);
		}
		mean = mean / pdt2data->permutations;
		variance = (square / pdt2data->permutations) - (mean * mean);
		sd = sqrt(variance /(pdt2data->permutations - 1));
		if(verbose){
			printf("### path= %i mean= %9.7f  var= %9.7f \n", i, mean, variance);
		}
		if(sd > epsilon){
			for(j = 0; j < pdt2data->permutations; j++){
				ES_P[i][j] = (ES_P[i][j] - mean) / sd;
			}
			ES[i] = (ES[i]-mean) / sd;
		}
		else{
			for(j = 0; j < pdt2data->permutations; j++){
				ES_P[i][j] = 0;
			}
			ES[i] = -1;			
		}
	}

//**********************************

	fp = fopen("permutation_Z-value.txt","w");

	for(i=0;i<num_pathway;i++) {
		fprintf(fp,"%8.6f ",ES[i]);
		for(j=0; j < pdt2data->permutations; j++) {
			fprintf(fp,"%8.6f ",ES_P[i][j]);
		}
		fprintf(fp,"\n");
	}
	fclose(fp);

//**********************************

	if(verbose){
		printf("Comparing original value to max. from each permutation\n");
	}	
	float maxf;
	max_perm = new float[pdt2data->permutations];
	float *multitestcorr = new float[pdt2data->permutations];
	float *adj_pval = new float[num_pathway];
	if(verbose){
		fp = fopen("ES_and_maxperm.dbg","w");
		fprintf(fp,"Max of one permutation over all pathways:\n");
	}
	for(i = 0; i < pdt2data->permutations; i++) {
		maxf = -99;
		for(j = 0; j < num_pathway; j++){
			if(ES_P[j][i] > maxf){
				maxf = ES_P[j][i];
			}
		}
		max_perm[i] = maxf;
		if(verbose){
			fprintf(fp,"M_%i %f\n",i, maxf);
		}
	}
	float cnt;
	if(verbose){
		fprintf(fp,"Now compare ES[i] > M_j, j = 0..%i\n", pdt2data->permutations-1);
	}
	for(i = 0; i < num_pathway; i++){
		cnt = 0;
		for(j = 0; j < pdt2data->permutations; j++){
			if(ES[i] < max_perm[j]){
				cnt += 1;
			}
		}
		adj_pval[i] = cnt / (float)pdt2data->permutations;
		if(verbose){
			fprintf(fp,"ES[%i]= %f  cnt= %i  adj_pval= %f\n",i, ES[i], (int)cnt, adj_pval[i]);
		}
	}
	if(verbose){
		fclose(fp);
	}
// Sorting Z-values by permutation (column)
	if(verbose){
		printf("Sorting permutation table\n");
	}
	FILE *fptr;
	if(verbose){
		fptr = fopen("ES_P_and_ES_new.dbg","w");
		fprintf(fptr,"[i,j]  ES_P[0][i]  ES[i]  toll1[i]  max_perm[i]\n");
	}
	Sort sorter;
	struct Record *list = new struct Record[num_pathway];

	int rank;
	for(i = 0;i < pdt2data->permutations; i++) {
		for(j = 0; j < num_pathway; j++){
			list[j].cov = ES_P[j][i];
		}

		sorter.init(num_pathway, list);
		sorter.qsort();
//printf("### perm= %i highest= %9.7f\n",i, list[num_pathway-1].cov);
		for(j = 0; j < num_pathway; j++) {
//printf(" %6.4f",ES[j]);
			if(list[num_pathway-1].cov > ES[j]){
				toll2[j]++;
			}
			if(ES_P[j][i] > ES[j]){
				toll1[j]++;
			}
			ES_P[j][i] = list[j].cov;
			if(verbose){
				fprintf(fptr,"[%i,%i]   %f   %f   %i\n", j, i, ES_P[j][i], ES[i], toll1[i]);
			}
		}
//printf("\n");
	}
	if(verbose){
		fclose(fptr);
	}
// Calculating FDR
	if(verbose){
		printf("Calculating FDR\n");
	}
	float *permvals = new float[num_pathway];
	float *sortedvals = new float[num_pathway];
	for(j = 0; j < num_pathway; j++){
		list[j].cov = ES[j];
	}
	sorter.init(num_pathway, list);
	sorter.qsort();
	for(j = 0; j < num_pathway; j++){
		permvals[j] = list[j].cov;
	}
	float st;
	float *sum = new float[num_pathway];
	float *fdr = new float[num_pathway];
	memset((void*)sum, 0, num_pathway * sizeof(float));
	
	for(j = 0; j < pdt2data->permutations; j++){
		for(k = 0; k < num_pathway; k++){
			sortedvals[k] = ES_P[k][j];
		}
		for(i = 0; i < num_pathway; i++){
			st = largerequal(sortedvals, num_pathway, ES[i]);
			if(st < 0){
				fprintf(stderr,"main::largerequal returns undefined value. item= %9.7f permutation= %i\n", ES[i], j);
			}
			else{
				sum[i] += st;
			}
		}
	}
	for(i = 0; i < num_pathway; i++){
		rank = findrank(permvals, num_pathway, ES[i]);
		if(rank < 0){
			fprintf(stderr,"main::largerequal returns undefined value. item= %9.7f permutation= %i\n", ES[i], j);
			fdr[i] = -1;
		}
		else{
			fdr[i] =  sum[i] / (float)(pdt2data->permutations * rank);
			if(fdr[i] > 1){
				fdr[i] = 1;
			}
		}
	}


#ifdef PROFILE
	PROFILE_STOP("main");
	ProfilePrint();
#endif
	ifstream myfile;
	char *line = new char[262144];
	char *token;
	fp = fopen(pdt2data->outfile_mrk, "w");
//	myfile.open(pdt2data->pathwayfile, ios::in);
	fprintf(fp,"Based on %i permutations:\n",pdt2data->permutations);
	fprintf(fp," Pathway_name  \"p(ES_P[pathw][i]>ES[pathw])\"     \"adj. p-val\"   FDR\n");
	for(i=0;i<num_pathway;i++) {
//		myfile.getline(line, 262143);
//		token = strtok(line, " ");
		double p1 = (double)toll1[i] / pdt2data->permutations;
//		double p2 = (double)toll2[i] / pdt2data->permutations;
		fprintf(fp,"%13s    %9.7f                     %9.7f     %9.7f\n", pathway_names[i], p1, adj_pval[i], fdr[i]);
	}
	fclose(fp);
//	myfile.close();
	delete [] line;
	delete [] toll1;
	delete [] toll2;
	delete [] list;
	delete [] sum;
	delete [] fdr;
	delete [] max_perm;
	delete [] permvals;
	delete [] sortedvals;
}


//*******************************************

void *reader_thread_startup(void *arg)
{
	Help_reader *arg1 = (Help_reader *)arg;
//	fprintf(stderr,"reader started\n");
	arg1->reader_instance.init(arg1->infile, arg1->loci, arg1->line_size, arg1->nmf, arg1->max_fam);		// will open infile
//	fprintf(stderr,"reader init\n");
	arg1->reader_instance.run();								// will process infile until EOF
//	fprintf(stderr,"reader run\n");
	return(NULL);
}

//*******************************************

void* consumer_thread_startup(void *arg)
{
	struct Help_consumer *arg1 = (Help_consumer *)arg;
//	fprintf(stderr,"consumer %i started\n",arg1->id);
	arg1->consumer_instance.init(arg1->num_loci, arg1->id, arg1->fr, arg1->hfr, arg1->check, arg1->window, arg1->opt, arg1->genopdt, arg1->max_ped_size, arg1->verbose, arg1->store_d, arg1->pdtave);
//	fprintf(stderr,"consumer %i successful init\n",arg1->id);
	arg1->consumer_instance.run();
//	fprintf(stderr,"consumer %i successful run\n",arg1->id);
	return(NULL);
}

//*******************************************

int get_cpus()
// find the number of CPUs, kind of important for multi-threading
{
#ifdef WIN32
	int cpus;
	struct _SYSTEM_INFO info;
	GetSystemInfo(&info);
	cpus = (int)info.dwNumberOfProcessors;
	if(cpus < 1){
		cpus = 1;
	}
	return(cpus);
#endif
#ifdef SOLARIS
	FILE *fptr;
	int cpus = 0;
	system("rm cpu.txt");
	system("mpstat | wc -l > cpu.txt");
	fptr = fopen("cpu.txt", "r");
	fscanf(fptr,"%i", &cpus);
	fclose(fptr);
	if(cpus < 2){
	  cpus = 2;
	}
	cpus--;
	return(cpus);
#endif
#ifdef LINUX
    FILE *fptr;
    char str[256];
    char ch;
    int i;
    int done;
    int cores;
    int cpus = 0;
    system("grep 'cpu cores' /proc/cpuinfo > cpu.txt");                // that's where Linux stores CPU info
                                    // core id         : 0
                                    // cpu cores       : 2
                                    // other "core id" will have one or more "cpu cores". So our job now is to add up all cpu cores across all cpu ids. Whatever that number is will be reported as "cpus" 

    fptr = fopen("cpu.txt", "r");
    while(! feof(fptr)){
        fgets(str, 256, fptr);
        i = strlen(str);
        done = 0;
        cores = 0;
        while((i > 0) && (done == 0)){
            ch = str[--i];
            if(((int)ch <= 57) && ((int)ch >= 49)){        // we assume somewhere between 1 - 9 cores per CPU. Reasonable for now.
                done = 1;
                cores = (int)ch - 48;
            }    
        }
        if(cores > 0){
            cpus += cores;
        }
        str[0] = '\0';
    }
    fclose(fptr);
    if(cpus == 0){
        cpus = 1;
    }
    return(cpus);
#endif

}

//*******************************************

struct Result* init_result(int num_loci, int max_fam_size, int cpus, struct Freq *fr, int check, int window, int verbose)
{
	int i;
	int size;
	int temp;
	int max = num_loci - window + 1;
	//###################################################################################################
	// first init the "result"
	//  struct Result{
	//	int pedigrees;							// init to 0, increment by one for each pedigree processed
	//	int size;								// number of loci & of pointer below
	//	float *data;							// init this to all zeros. Each consumer gets to update this with their own data (also of type "struct Result"
	//	pthread_mutex_t mut_consumer;			// lock if "Global_data" is updated, that's only between competing consumers
	//};
	struct Result *result;
	size = sizeof(float) * num_loci;
	result = new struct Result;
	if(result == NULL){
		fprintf(stderr,"bad memory allocation \"result\", bailing out.\n");
		exit(0);
	}
	result->data1 = NULL;
	result->data2 = NULL;
	result->data3 = NULL;
	result->data4 = NULL;
	result->data5 = NULL;
	result->data6 = NULL;
	result->data7 = NULL;
	result->data8 = NULL;
	result->data1 = new float*[max];							// needed to store result
	result->data2 = new float*[max];
	result->data3 = new int*[max];
	if(verbose){
		result->data4 = new int*[max];
		result->data5 = new int*[max];
		result->data6 = new int*[max];
		result->data7 = new int*[max];
		result->data8 = new int*[max];
	}
	/*
	if(!check){
		result->ns = new int;
		result->nt = new int;
		*result->ns = 0;
		*result->nt = 0;
	}
	else{
	*/
	result->ns = new int[max];
	result->nt = new int[max];	
	result->fams = new int[max];
	memset((void*)result->fams, 0, max * sizeof(int));
	memset((void*)result->ns, 0, max * sizeof(int));
	memset((void*)result->nt, 0, max * sizeof(int));
//	}
	if((result->data1 == NULL) || (result->data2 == NULL)){
		fprintf(stderr,"bad memory allocation \"result->data\", bailing out.\n");
		exit(0);
	}
	result->pedigrees = 0;										// so far no pedigrees processed
	result->size = num_loci;									// ...just for convenience
	for(i = 0; i < max; i++){
		result->data1[i] = new float[fr->numall[i]];
		result->data2[i] = new float[fr->numall[i]];
		result->data3[i] = new int[fr->numall[i]];
		if(1 == verbose){
			result->data4[i] = new int[fr->numall[i]];
			result->data5[i] = new int[fr->numall[i]];
			result->data6[i] = new int[fr->numall[i]];
			result->data7[i] = new int[fr->numall[i]];
			result->data8[i] = new int[fr->numall[i]];
			memset((void*)result->data4[i], 0, fr->numall[i] * sizeof(int));
			memset((void*)result->data5[i], 0, fr->numall[i] * sizeof(int));
			memset((void*)result->data6[i], 0, fr->numall[i] * sizeof(int));
			memset((void*)result->data7[i], 0, fr->numall[i] * sizeof(int));
			memset((void*)result->data8[i], 0, fr->numall[i] * sizeof(int));
		}
		memset((void*)result->data1[i], 0, fr->numall[i] * sizeof(float));
		memset((void*)result->data2[i], 0, fr->numall[i] * sizeof(float));
		memset((void*)result->data3[i], 0, fr->numall[i] * sizeof(int));
	}
	if( (temp = pthread_mutex_init(&result->mut_consumer, NULL)) != 0){
		fprintf(stderr,"could not init mutex \"result->mut_consumer\", bailing out.\n");
		exit(0);
	}
	return(result);
}

//*******************************************

struct Result* init_result_geno(int num_loci, int max_fam_size, struct Freq *fr)
{
	int i;
	int size;
	int temp;
	int max = num_loci;
	//###################################################################################################
	// first init the "result"
	//  struct Result{
	//	int pedigrees;							// init to 0, increment by one for each pedigree processed
	//	int size;								// number of loci & of pointer below
	//	float *data;							// init this to all zeros. Each consumer gets to update this with their own data (also of type "struct Result"
	//	pthread_mutex_t mut_consumer;			// lock if "Global_data" is updated, that's only between competing consumers
	//};
	struct Result *result;
	size = sizeof(float) * num_loci;
	result = new struct Result;
	if(result == NULL){
		fprintf(stderr,"bad memory allocation \"result\", bailing out.\n");
		exit(0);
	}
	result->data1 = NULL;
	result->data2 = NULL;
	result->data3 = NULL;
	result->data4 = NULL;
	result->data5 = NULL;
	result->data6 = NULL;
	result->data7 = NULL;
	result->data1 = new float*[max];							// needed to store result
	result->data2 = new float*[max];
	result->data3 = new int*[max];
	/*
	if(!check){
		result->ns = new int;
		result->nt = new int;
		*result->ns = 0;
		*result->nt = 0;
	}
	else{
	*/
	result->ns = new int[max];
	result->nt = new int[max];	
	result->fams = new int[max];
	memset((void*)result->fams, 0, max * sizeof(int));
	memset((void*)result->ns, 0, max * sizeof(int));
	memset((void*)result->nt, 0, max * sizeof(int));
//	}
	if((result->data1 == NULL) || (result->data2 == NULL)){
		fprintf(stderr,"bad memory allocation \"result->data\", bailing out.\n");
		exit(0);
	}
	result->pedigrees = 0;										// so far no pedigrees processed
	result->size = num_loci;									// ...just for convenience
	for(i = 0; i < max; i++){
		size = (fr->numall[i] * (fr->numall[i] + 1)) / 2;		// genotypes = (alleles * (alleles + 1)) / 2
		result->data1[i] = NULL;
		result->data2[i] = NULL;
		result->data3[i] = NULL;
		result->data1[i] = new float[size];
		result->data2[i] = new float[size];
		result->data3[i] = new int[size];
		if(result->data1[i] == NULL){
			fprintf(stderr,"main::init_result_geno. Memory allocation for result->data1[%i] failed\n",i);
			exit(0);
		}
		if(result->data2[i] == NULL){
			fprintf(stderr,"main::init_result_geno. Memory allocation for result->data2[%i] failed\n",i);
			exit(0);
		}
		if(result->data3[i] == NULL){
			fprintf(stderr,"main::init_result_geno. Memory allocation for result->data3[%i] failed\n",i);
			exit(0);
		}

		memset((void*)result->data1[i], 0, size * sizeof(float));
		memset((void*)result->data2[i], 0, size * sizeof(float));
		memset((void*)result->data3[i], 0, size * sizeof(int));
	}
	if( (temp = pthread_mutex_init(&result->mut_consumer, NULL)) != 0){
		fprintf(stderr,"could not init mutex \"result->mut_consumer\", bailing out.\n");
		exit(0);
	}
	return(result);
}

//*******************************************

struct Fam* init_fam(int num_loci, int max_fam_size, int cpus, int naf)
	// args:
	// num_loci = number of loci in .ped file
	// max_fam_size = max. number of members in pedigree. usually 2-parents + n-children = "2+n"
	// cpus = number of CPUs on this machine
	// naf = non-allele fields in .ped file (like pedigreeID, sex, etc.)
{
	int i,j;
	int size;
	int num_fams = 2 * cpus + 2;								// just some arbitrary number more than twice the number of CPUs

	//######################################################################################################
	// second init "families"
	//	struct Fam{								// structure that holds the data
	//	int members;							// each Family has 2 parents and "members - 2" children
	//	int loci;								// number of loci, kind of redundant since all Fams are going to have the same number
	//	unsigned char **geno;					// geno[i][j] is for the ith member and jth locus
	//											// geno[i][0] holds 0|1. 0 = not genotyped, 1 = valid data
	//};						
	Fam *families;
	families = new struct Fam[num_fams];						// total number of Fam type structures
	if(families == NULL){
		fprintf(stderr,"bad memory allocation \"families\", bailing out.\n");
		exit(0);
	}
	for(i = 0; i < num_fams; i++){
		families[i].members = 0;
		families[i].loci = num_loci;							// somewhat redundant...but still
		families[i].geno = NULL;
		families[i].geno = new unsigned char*[max_fam_size];	// 2 parents and 2+ children makes some 4+ members (user specified)
		if(families[i].geno == NULL){
			fprintf(stderr,"bad memory allocation \"families[%i].geno\", bailing out.\n", i);
			exit(0);
		}
		size = (num_loci+naf) * sizeof(unsigned char);				// Of course sizeof(unsigned char) == 1...just in case pigs learn to fly
		for(j = 0; j < max_fam_size; j++){
			families[i].geno[j] = NULL;
			families[i].geno[j] = new unsigned char[num_loci+naf];	// we need the "+6" since the [0] entry holds genotyping info (0=not typed, 1= typed)
																	// 1-5 hold "other info"
			if(families[i].geno[j] == NULL){
				fprintf(stderr,"bad memory allocation \"families[%i].geno[%i]\", bailing out.\n", i, j);
				exit(0);
			}
			memset((void*)families[i].geno[j], 0, size);
		}

	}
	return(families);
}
//*******************************************

struct Read_sync* init_sync(int num_loci, int max_fam_size, int cpus)
{
	int i;
	int temp;
	int num_fams = 2 * cpus + 2;

	//########################################################################################################
	// third init read_synchronizer
	//	struct Read_sync{							// structure that tells use where the data is, what is used, what is ready and what is empty
	//	int done;									// initialized to 0, when EOF is encountered the reader sets it to 1 and returns a "not genotyped" Fam upon call to next().
	//												// Consumers decremts "thread_count" and exits. Upon a "thread_count" of 0 the reader exits as well.
	//	int thread_count;							// Number of active consumer threads. Return when this number reaches 0.
	//	int size;									// how many items (i.e. struct Fam) are in list
	//	int free;									// how many items are ready to be filled by producer (i.e. reader)
	//	int ready;									// how many items are filled by producer, waiting to be consumed
	//	int *list;									// status of each "struct Fam".		-1 = free, ready to recieve data
	//												//									0  = ready, filled with data, waiting to be consumed
	//												//									1  = currently being used by consumer
	//	pthread_mutex_t mut_reader;					// lock if "Read_sync" is updated, that's between ONE reader and 1+ consumer(s)
	//	pthread_cond_t cond_waiting_producer;		// if reader is waiting on consumers
	//	pthread_cond_t cond_waiting_consumer;		// if consumer is waiting on producer/reader

	//};
	Read_sync *read_synchronizer;
	read_synchronizer = new struct Read_sync;
	if(read_synchronizer == NULL){
		fprintf(stderr,"bad memory allocation \"read_synchronizer\", bailing out.\n");
		exit(0);
	}															// num_fams = 2 * cpus + 2;
	read_synchronizer->thread_count = 0;						// no threads active at this point
	read_synchronizer->free = num_fams;							// they are allwaiting to be filled with data
	read_synchronizer->ready = 0;								// no items are ready to be consumed initially
	read_synchronizer->size = num_fams;							// this is never going to change...kind of redundant
	read_synchronizer->done = 0;								// we are far from done, barely getting started
	read_synchronizer->ped_id = 0;								// updat (++) that for each pedigree used by consumer
	read_synchronizer->list = NULL;								// for right now, to see if memory allocation succeeded
	read_synchronizer->list = new int[num_fams];
	if(read_synchronizer->list == NULL){
		fprintf(stderr,"bad memory allocation \"read_synchronizer->list\", bailing out.\n");
		exit(0);
	}
	for(i = 0; i < num_fams; i++){
		read_synchronizer->list[i] = -1;						// see above for explanation
	}
	if( (temp = pthread_mutex_init(&read_synchronizer->mut_reader, NULL)) != 0){
		fprintf(stderr,"could not init mutex \"read_synchronizer->mut_reader\", bailing out.\n");
		exit(0);
	}
	if( (temp = pthread_cond_init(&read_synchronizer->cond_waiting_consumer, NULL)) != 0){
		fprintf(stderr,"could not init condition \"read_synchronizer->cond_waiting_consumer\", bailing out.\n");
		exit(0);
	}
	if( (temp = pthread_cond_init(&read_synchronizer->cond_waiting_producer, NULL)) != 0){
		fprintf(stderr,"could not init condition \"read_synchronizer->cond_waiting_producer\", bailing out.\n");
		exit(0);
	}
	return(read_synchronizer);
}

//*******************************************

int get_num_loci(char *infile, int &size, int nmf)
{
	int result = 1;
	char *dummy;
	ifstream inf;
	string str;
	inf.open(infile, ios::in);
	if(inf.is_open()){
		getline(inf,str);
	}
	else{
		fprintf(stderr,"main::get_num_loci. Could not open infile %s\n", infile);
		exit(0);
	}
	inf.close();
	size = str.size() + 1;
	dummy = new char[size];
	strcpy(dummy, str.data());
	if(strstr(dummy, "\t")){
		fprintf(stderr,"main::get_num_loci. Your file contains tabs. Un-tabify your file. Then try again. Bailing out.\n");
		exit(0);
	}
	strtok(dummy," ");
	while(NULL != strtok(NULL, " ")){
		result++;
	}
	delete [] dummy;
	result -= nmf;
	result /= 2;
	return(result);
}
//*******************************************


struct Freq* read_freq(char *infreq, int num_loci)
{
//	struct Freq{
//	int *numall;							// # of alleles for ith locus
//	float **afreq;							// freq. of marker alleles, sum == 1
	struct Freq *fr = NULL;
//	float temp[max_allele];
	fr = new Freq;
	fr->afreq = NULL;
	fr->numall = NULL;

	int i = 0;							// ith locus	
	int count = 0;						// count of alleles
	const int max_size = 100;
	char *str = new char[max_size];

	fr->numall = new int[num_loci];

	if((fr == NULL) || (fr->numall == NULL) ){
		cerr <<"main::read_freq. memory allocation error, bailing out."<<endl;
		exit(0);
	}
	//// now read in the .freq file and allocate memeory to each locus according to the number of alleles ////
	ifstream inf;
	inf.open(infreq, ios::in);
	if(!inf.is_open()){
		cerr <<"main::read_freq. Unable to open "<<infreq<<". Good bye."<<endl;
		exit(0);
	}
	while(!inf.eof()){
		inf.getline(str, max_size);
		if(strchr(str, 'F')){			// 'F' like frequency
			count++;
		}
		else if(strchr(str, 'M')){		// start new marker
			if(count > 0){
				fr->numall[i] = count;
				i++;
				if(count == 1){
					cerr <<"main::read_freq. Locus "<<i<<" has only 1 allele, bailing out."<<endl;
					exit(0);
				}
				count = 0;				// reset count
			}
		}
	}
	inf.close();
	if(count > 0){
		fr->numall[i] = count;
		i++;
		if(count == 1){
			cerr <<"main::read_freq. Locus "<<i<<" has only 1 allele, bailing out."<<endl;
			exit(0);
		}
		count = 0;	
	}
	delete [] str;
	return(fr);
}

//*******************************************

struct Freq* allocate_Freq(int num_loci)
{
	int i;
	// allocate memory for list with number of alleles
	struct Freq* fr;
	fr = new Freq;
	fr->afreq = NULL;
	fr->numall = NULL;
	fr->numall = new int[num_loci];
	if((fr == NULL) || (fr->numall == NULL) ){
		cerr <<"main::read_map_file. memory allocation error, bailing out."<<endl;
		exit(0);
	}
	return(fr);
}

//*******************************************

char** read_map_file(struct Freq* fr, int num_loci, char *filename)
{
	char **name_list = NULL;
	const int namelength = 15;
	int length;
	int i,j;
	// allocate memorty for list with marker names
	name_list = new char*[num_loci];
	for(i = 0; i < num_loci; i++){
		name_list[i] = new char[namelength];
	}
	int count = 0;						// count of alleles
	const int max_size = 200;
	char *token_ptr;
	char *str = new char[max_size];

	// now open infile and start reading
	ifstream inf;
	inf.open(filename, ios::in);
	if(!inf.is_open()){
		cerr <<"main::read_map_file. Unable to open "<<filename<<". Good bye."<<endl;
		exit(0);
	}
	count = 0;
	char *ptr_tab;										// pointer to first tab
	char *ptr_space;									// pointer to first space
	char temp[10];
	while((!inf.eof()) && (count < num_loci)){
		inf.getline(str, max_size);
		length = (int)strlen(str);
		if(length < 3){
			break;
		}
		i = 0;
		while(str[i] >= '!') i++;						
		while((str[i] == ' ') || (str[i] == '\t')) i++;
		j = 0;
		while(str[i] >= (int)'!'){
			name_list[count][j] = str[i];
			i++;
			j++;
		}
		name_list[count][j] = '\0';
		while((str[i] == ' ') || (str[i] == '\t')) i++;	
		while(str[i] >= '!') i++;						// eat the "physical location
		while((str[i] == ' ') || (str[i] == '\t')) i++;	// eat more whitespace
		if((str[i] == '\n') || (str[i] == 0)){								// test for newline
			fr->numall[count] = 2;
		}
		else{
			while((str[i] == ' ') || (str[i] == '\t')) i++;	// eat last white-space
			j = 0;
			while(str[i] >= '!'){
				temp[j] = str[i];
				j++;
				i++;
			}
			temp[j] = '\0';
			fr->numall[count] = atoi(temp);
		}
		count++;
	}
	inf.close();
	delete [] str;
//	delete [] temp;
	// now do some error checking
	if(count != num_loci){
		fprintf(stderr,"main::read_map_file. Expected %i loci in %s. Read %i. Bailing out\n", num_loci, filename, count);
		exit(0);
	}
	// dbg start
	/*
	FILE *fptr;
	fptr = fopen("dbg.txt", "w");
	for(i = 0; i < num_loci; i++){
		for(j = 0; j < 10; j++){
			temp[j] = name_list[i][j];
		}
		fprintf(fptr,"%s   %i\n", name_list[i], fr->numall[i]);

	}
	fclose(fptr);
	*/
	// dbg stop
	return(name_list);
}

//*******************************************

struct Freq * make_hpa_freq(int num_loci, int window, struct Freq *fr)
{
	struct Freq *hapfr = NULL;
	int i,j;
	int multiplier = 1;
	int size = num_loci - window + 1;
	hapfr = new Freq;
	hapfr->numall = new int[size];
	if((hapfr == NULL) || (hapfr->numall == NULL)){
		cerr <<"main::make_hap_freq. memory allocation error, bailing out."<<endl;
		exit(0);
	}
	for(i = 0; i < window; i++){
		multiplier *= fr->numall[i];
	}
	for(i = window, j = 0; i < num_loci;i++, j++){
		hapfr->numall[j] = multiplier;
		multiplier *= fr->numall[i];
		multiplier /= fr->numall[i - window];
	}
	hapfr->numall[size-1] = multiplier;
	return(hapfr);
}

//*******************************************

char** read_mrklist(char* filename, unsigned int &mrklistsize)
{
	int i = 0;
	int size = 0;
	char **list = NULL;
	char buffer[maxnamesize];
	/*
	ifstream infile;
	infile.open(filename, ios::in);
	while(infile.getline(buffer, maxnamesize)){
		size++;
	}
	*/
	FILE *fptr;
	fptr = fopen(filename, "r");
	while(!feof(fptr)){
		fscanf(fptr,"%s", buffer);
		size++;
	}
	mrklistsize = findlargerprime(size);
	list = new char*[mrklistsize];
	for(i = 0; i < mrklistsize; i++){
		list[i] = new char[maxnamesize];
		list[i][0] = '\0';							// initialize with empty string
	}
//	infile.close();
//	infile.seekg(0, ios::beg);
//	infile.open(filename, ios::in);
//	if(!infile.is_open()){
//		cerr <<"Error opening infile"<<endl;
//	}
	rewind(fptr);
	while(!feof(fptr)){
		fscanf(fptr,"%s", buffer);
//	while(infile.getline(buffer, maxnamesize)){
		i = hash(buffer, mrklistsize);
		while(list[i][0] != '\0'){
			i++;
			if(i == mrklistsize){
				i = 0;
			}
		}
		strcpy(list[i], buffer);
		buffer[0] = '\0';							// reset buffer[] to NULL string
	}
//	infile.close();
	fclose(fptr);
	return(list);
}

//*******************************************

unsigned int hash(char *buffer, unsigned int size)
{
	// algorithm based on dan bernstein 
	unsigned int hash = 5381;
	unsigned int c;
	while(c = (unsigned int)*buffer++){
		hash = ((hash << 5) + hash) + c;				/* hash * 33 + c */
	}
	hash %= size;										// hash mod size
	return(hash);
}

//*******************************************

int findlargerprime(int start)
{
	int candidate = (2 * start) + 1;						// so we want a number at least twice the size
	int square_root = (int)sqrt((double)candidate);
	int done = 0;
	int divisor;
	while(done == 0){
		divisor = 3;
		while(((double)(candidate/divisor) != ((double)candidate / (double)divisor)) && (divisor <= square_root)){
			divisor += 2;
		}
		if(divisor > square_root){
			done = 1;
		}
		if(done == 0){
			candidate += 2;
			square_root = (int)sqrt((double)candidate);
		}
	}
	return(candidate);
}

//*******************************************

int is_in_list(char **rslist, char *item, unsigned int list_size)
{
	int result = 0;											// for now assume it's not in list
	unsigned int h = hash(item, list_size);
	int done = 0;
	int temp;
	while(done == 0){
		if(rslist[h][0] == '\0'){								// string not in list, we're done
			done = 1;
		}
		else{
			temp  = strcmp(item, rslist[h]);
			if(temp == 0){
				done = 1;
				result = 1;
			}
			else{
				h++;										// increment index
				if(h == list_size){							// check if we "wrapped around"
					h = 0;
				}
			}
		}
	}
	return(result);
}

//*******************************************

int get_number_of_pedigrees(char* filename, int size)
{
	char *line = new char[size+1];
	ifstream inf;
	int count = 0;
	int previous = -1;
	int current;
	inf.open(filename, ios::in);
	if(!inf.is_open()){
		fprintf(stderr,"main::get_number_of_pedigrees. Failed to open %s, bailing out.\n", filename);
		exit(0);
	}
	while(inf.getline(line, size)){
		current = atoi(strtok(line, " "));
		if(current != previous){
			previous = current;
			count++;
		}
	}
	//count++;
	delete [] line;
	return(count);
}

//*******************************************
//***** LIBRARY stuff ***********************

void read_gene_file() {
	ifstream myfile("g_index.txt");
	int digit;
	int m,n;
	m = n = 0;

	if (myfile.is_open()) {
		while (! myfile.eof() ) {
			myfile >> digit;

			if(digit==-9) {
				g_index[m][n] = -1;
				m++;
				n=0;
			} else {
				g_index[m][n] = digit;
				n++;
			}
		}
	}
	num_genes = m-1;
	myfile.close();
}

//*********************************************

int** read_pathway_file(int &num_pathway, char *filename) {
	ifstream myfile;
	int **plst = NULL;
	int index;
	int size;
	int m,n,i,j;
	char *line = new char[262144];
	int *tempindex = new int[25000];
	char *token;
	m = n = 0;
	myfile.open(filename, ios::in);
	num_pathway = 0;
	if (myfile.is_open()) {
		while(myfile.getline(line, 262143)){
			num_pathway++;
		}
		plst = new int*[num_pathway];								// we have this many pathways total
		pathway_names = new char*[num_pathway];
		myfile.clear();
		myfile.seekg(0, ios::beg);
		while(myfile.getline(line, 262143)){
			token = strtok(line, " ");								// pathway name
			size = strlen(token) + 1;
			pathway_names[m] = new char[size];
			strcpy(pathway_names[m], token);
			token = strtok(NULL, " ");								// 1st gene
			n = 0;
			while(NULL != token){
				index = hashtable.queryrecord(token);
				if(index >= 0){										// only deal with genes that are in hashtable (ie. those that have 1+ SNPs)
					tempindex[n] = index;
					n++;
				}
				token = strtok(NULL, " ");
			}														// now all valid gene indices sit in tempindex[]
			plst[m] = NULL;
			plst[m] = new int[n+1];
			if(plst[m] == NULL){
				fprintf(stderr,"main::read_pathway_file. Memory allocation for plst[%i] failed\n",m);
				exit(0);
			}
			for(i = 0; i < n; i++){
				plst[m][i] = tempindex[i];
			}
			plst[m][n] = -1;
			m++;
		}
		myfile.close();
	}
	else{
		fprintf(stderr,"main::read_pathway_file. Can not open %s. Bailing out.\n",filename);
		exit(0);
	}
	delete [] tempindex;
	delete [] line;
	return(plst);
}

//*********************************************

void read_simpleM_file() {
	ifstream myfile("s_index.txt");
	int digit;
	int n;
	n = 0;

	if (myfile.is_open()) {
		while (! myfile.eof() ) {
			myfile >> digit;

			s_index[n] = digit;
			n++;
		}
	}
	myfile.close();
}

//*********************************************

void *pathway_thread_startup(void *arg)
{
	Help_pathway_thread *arg1 = (Help_pathway_thread *)arg;
	struct pathway_info *pathway_arg;
	pathway_arg = new struct pathway_info;
	pathway_arg->num_threads = arg1->num_threads;
	pathway_arg->id = arg1->id;
	pathway_arg->num_loci = arg1->num_loci;
	pathway_arg->num_genes = arg1->num_genes;
	pathway_arg->num_pathway = arg1->num_pathway;
	pathway_arg->num_pedigrees = arg1->num_pedigrees;
	pathway_arg->permutations = arg1->permutations;
	pathway_arg->verbose = arg1->verbose;
	arg1->pathway_instance.run(pathway_arg);								
	return(NULL);
}

//*********************************************

void *random_thread_startup(void *arg)
{
	Help_random *arg1 = (Help_random *)arg;
	arg1->random_instance.run_thread();
	arg1->random_instance.bye();
	return(NULL);
}

//*********************************************
/*
struct SNPinfo{
	int chrom;
	int position;
	int id;
};
*/
struct SNPinfo * getsnpinfo(int &snpsinmapfile, char *mapfile)
{
	snpsinmapfile = 0;
	char *line = new char[1024];
	char *token;
	struct SNPinfo *snplst = NULL;
	int ch,pos,id;
	ifstream infile;
	int i = 0;
	infile.open(mapfile, ios::in);
	if (infile.is_open()){
		while(infile.getline(line, 1023)){
			snpsinmapfile++;
		}
		snplst = new struct SNPinfo[snpsinmapfile];
		infile.clear();
		infile.seekg(0, ios::beg);
		while(infile.getline(line, 1023)){
			token = strtok(line, " ");
			snplst[i].chrom = atoi(token);
			token = strtok(NULL, " ");
			token = strtok(NULL, " ");
			snplst[i].position = atoi(token);
			snplst[i].id = i;
			i++;
		}
	}
	else{
		fprintf(stderr,"main::getsnpinfo. Can not open %s. Bailing out.\n", mapfile);
		exit(0);
	}
	infile.close();
	delete [] line;
	return(snplst);
}

//*********************************************

/*
struct Gene{
	unsigned char chrom;
	unsigned int start;
	unsigned int stop;
	unsigned int snps;
	float best_pdt;
	SNPnode *head;
};

int **p_index;				// pathway index, contains index of all genes in that pathway. Terminated with -1
int **g_index;				// gene index, contains index of all SNPs in that gene. May contain genes that are not listed in p_index. Terminated with -1
short *s_index;				// list of integers from the "s_index.txt" file corresponding to the genes in g_index

*/
int** fillgindex(int &num_genes, struct SNPinfo *snplist, int snpsinmapfile, short *&s_index, int new_gene_file, int gene_buffer, char *gene_file_name, char *sindex_file, 	unsigned char *&genes_used)
{
	char *token;
	char *genename;
	int chrom;
	int start, stop;
	int index;
	int temp;
	int totalgenes = 0;
	int snpsinnew = 0;
	int i,j,k,m;
	int position;
	snpsused = new unsigned char[snpsinmapfile];
	int **gindex = NULL;
	int *snpsingene = NULL;
	char *line = new char[1024];
	char *sline = new char[1024];
	snpsingene = new int[max_snps_in_gene];
	if(NULL == snpsingene){
		fprintf(stderr,"main::fillgindex. Memory allocation failed, bailing out\n");
		exit(0);
	}
	ofstream outfile;
	ofstream outfile2;
	FILE *fptr2;

	memset((void*)snpsused, 0, snpsinmapfile*sizeof(unsigned char));
	num_genes = 0;
	ifstream infile;
	ifstream sindexfilestr;
	infile.open(gene_file_name, ios::in);
	// first get an idea how many genes have one or more SNPs in them

	if (infile.is_open()){

		while(infile.getline(line, 1023)){

			genename = strtok(line, " ");
			token = strtok(NULL, " ");
			chrom = atoi(token);
			token = strtok(NULL, " ");
			start = atoi(token);
			token = strtok(NULL, " ");
			stop = atoi(token);
			stop += gene_buffer;
			start -= gene_buffer;
			if(start < 0) start = 0;
			position = findfirstsnp(chrom, start, snpsinmapfile, snplist);
			if((position >= 0) && (snplist[position].position < stop)){
				hashtable.insertrecord(genename, num_genes);
				num_genes++;													// this gene has one (or more) SNPs in the map file
				while((position < snpsinmapfile) && (snplist[position].position < stop) && (snplist[position].chrom == chrom)){
					snpsused[position] = 1;
					position++;
				} //while((snplist[position].position < stop) && (snplist[position].chrom == chrom))
			}
			totalgenes++;
		}

	}
	else{
		fprintf(stderr,"main::fillgenearray. Can not open %s. Bailing out.\n",gene_file_name);
		exit(0);
	}	
	infile.close();
	genes_used = new unsigned char[totalgenes];
	memset((void*)genes_used, 0, totalgenes*sizeof(unsigned char));
	temp = 0;
	for(i = 0; i < snpsinmapfile; i++){
		if(snpsused[i]){
			snpsinnew++;	
		}
	}

	sindexfilestr.open(sindex_file, ios::in);
	int ones = 0;
	if(!sindexfilestr.is_open()){
		ones = 1;											// the s_index files does not exist. Use all 1s.
	}
	gindex = new int*[num_genes];
	if(NULL == gindex){
		fprintf(stderr,"main::fillgindex. Memory allocation failed, bailing out\n");
		exit(0);
	}
	s_index = new short[num_genes];
	for(i = 0; i < num_genes; i++){
		gindex[i] = NULL;
	}
	memset((void*)s_index, -1, num_genes * sizeof(short));
//	FILE *dbg = fopen("snplist.txt","w");
//	for(i = 0; i < snpsinmapfile; i++){
//		fprintf(dbg,"%i. %i  %i  %i\n",i,snplist[i].chrom,snplist[i].position,snplist[i].id);
//	}
//	fclose(dbg);
	FILE *fptr;
	if(verbose){
		fptr = fopen("genes.dbg","w");
	}
	m=0;
//	totalgenes = 0;
	/*

	*/
	infile.open(gene_file_name, ios::in);
	infile.clear();
	infile.seekg(0, ios::beg);
	if(new_gene_file){
		outfile.open("gene_pos.new", ios::out);
		outfile2.open("s_index.new", ios::out);
	}
	int unique = 0;
	while(infile.getline(line, 1023) && (ones || sindexfilestr.getline(sline, 1023))){
		if(ones){
			temp = 1;
		}
		else{
			token = strtok(sline, " ");
			temp = atoi(token);
		}
		genename = strtok(line, " ");
		token = strtok(NULL, " ");
		chrom = atoi(token);
		token = strtok(NULL, " ");
		start = atoi(token);
		token = strtok(NULL, " ");
		stop = atoi(token);
		stop += gene_buffer;
		start -= gene_buffer;
		if(start < 0) start = 0;
		position = findfirstsnp(chrom, start, snpsinmapfile, snplist);
		if((position >= 0) && (snplist[position].position < stop)){
			j = 0;
			while((position < snpsinmapfile) && (snplist[position].position < stop) && (snplist[position].chrom == chrom)){
				snpsingene[j] = position;
				j++;
				position++;
				if(j >= max_snps_in_gene){
					fprintf(stderr,"main::fillgindex. Maximum SNPs per gene (%i) exceeded. Gene name= %s chrom= %i start= %i stop= %i\n", max_snps_in_gene, genename, chrom, start, stop);
					exit(0);
				}
			} //while((snplist[position].position < stop) && (snplist[position].chrom == chrom))
			i = hashtable.queryrecord(genename);
			if(new_gene_file /*&& (0 == genes_used[i])*/){
				stop -= gene_buffer;
				start += gene_buffer;
				outfile <<genename<<" "<<chrom<<" "<<start<<" "<<stop<<endl;
				outfile2 <<temp<<endl;
			}
			unique++;
			genes_used[i]++;
			if(gindex[i] == NULL){
				if(verbose){
					fprintf(fptr, "%i. %20s   %3i\n",i,genename, temp);
				}
				gindex[i] = new int[j+1];
				if(NULL == gindex[i]){
					fprintf(stderr,"main::fillgindex. Memory allocation failed, bailing out\n");
					exit(0);
				}
				for(k = 0; k < j; k++){
					gindex[i][k] = snpsingene[k];
				}
				gindex[i][j] = -1;
			}
			s_index[i] = temp;
		}
		m++;
	} // while(infile.getline(line, 1023) && sindexfile.getline(sline, 1023))
	if(verbose){
		fclose(fptr);
	}
	if(new_gene_file){
		outfile.close();
		outfile2.close();
// print the ORIGINAL g_index file with the SNP IDs as they would show up in the original map/ped files.
		if(verbose){
			fptr2 = fopen("g_index_orig.dbg","w");
		}
		for(i = 0; i <  num_genes; i++){
			j = 0;
			while(gindex[i][j] != -1){
				if(verbose){
					fprintf(fptr2," %i", gindex[i][j]);
				}
				j++;
			}
			if(verbose){
				fprintf(fptr2," -9\n");
			}
		}
		if(verbose){
			fclose(fptr2);
		}
	}
	if(m != totalgenes){
		fprintf(stderr,"main::fillgindex. The number of entries in %s (%i) and %s (%i) must be identical. Please fix. Bye.\n", gene_file_name, sindex_file, totalgenes, m);
		exit(0);
	}
	for(i = 0; i < num_genes; i++){
		if(gindex[i] == NULL){
			fprintf(stderr,"main::int** fillgindex. Could not find gene for index %i.\n",i);
			gindex[i] = new int[1];
			gindex[i][0] = -1;
		}
	}
	infile.close();
	if(!ones){
		sindexfilestr.close();
	}
	delete [] line;
	delete [] sline;
	delete [] snpsingene;
	
	return(gindex);
}

//*********************************************

int findfirstsnp(int chrom, int start, int size, struct SNPinfo *snplist)
// returns position of 1st SNP that is bigger than the gene start position
{
	int first = 0;
	int last = size-1;
	int median;
	int result = -1;
	while(1){
		if(first > last) break;
		median = (first + last) / 2;
		if(snplist[median].chrom < chrom){
			first = median + 1;
		}
		else if(snplist[median].chrom > chrom){
			last = median - 1;
		}
		else{														// they are equal, we're on the right chromosome. Now it gets tricky
			if(snplist[median].position < start){
				first = median + 1;
			}
			else if(snplist[median].position > start){
				if(median == 0){
					result = snplist[median].id;
					break;					
				}
				if((snplist[median-1].position < start) || (snplist[median-1].chrom < chrom)){
					result = snplist[median].id;
					break;					
				}
				else{
					last = median - 1;
				}
			}
			else{													// we're spot on
				result = snplist[median].id;
				break;
			}
		}
	}
	return(result);
}

//*********************************************

int getnumgenes(char *genefilename)
{
	int numgenes = 0;
	char *line = new char[1024];
	ifstream infile;
	infile.open(genefilename, ios::in);
	if(infile.is_open()){
		while(infile.getline(line, 1023)){
			numgenes++;
		}
	}
	else{
		fprintf(stderr,"main::getnumgenes. Can not open %s. Bailing out.\n",genefilename);
		exit(0);
	}
	infile.close();
	return(numgenes);
}

//*********************************************

void print_index()
{
	FILE *fptr;
	int i,j;
	unsigned int index;

	// print short *s_index first, one entriy per line
	if(verbose){
		fptr = fopen("s_index.dbg","w");
		for(i = 0; i < num_genes; i++){
			fprintf(fptr,"%i. %6i\n",i,s_index[i]);
		}
		fclose(fptr);
	// print int **g_index below
		fptr = fopen("g_index.dbg","w");
		for(i = 0; i < num_genes; i++){
			j = 0;
			fprintf(fptr,"%i. ",i);
			while(g_index[i][j] != -1){
				fprintf(fptr," %i",g_index[i][j]);
				j++;
			}
			fprintf(fptr,"\n");
		}
		fclose(fptr);
	// print int **P-index below
		fptr = fopen("p_index.dbg","w");
		for(i = 0; i < num_pathway; i++){
			j = 0;
			fprintf(fptr,"%i. ",i);
			while(p_index[i][j] != -1){
				fprintf(fptr," %i",p_index[i][j]);
				j++;
			}
			fprintf(fptr,"\n");
		}
		fclose(fptr);
	}
}

//**********************************************

void print_new_map_ped(char *mapfile, char *pedfile, int nmf, int snpsinmapfile, int buf, char *gene_file_name, char *sindex_file, struct SNPinfo *snplist, unsigned char *genes_used)
{
//snpsused
	//snpsinmapfile
	int i;
	char *token;
	char *genename;
	int chrom, start, stop, position;
	int size = 1000+4*snpsinmapfile;
	char *line = new char[size+1];
	ifstream infile;
	ofstream outfile;
// print new .map file
	infile.open(mapfile, ios::in);
	outfile.open("map.new", ios::out);
	i = 0;
	while(infile.getline(line, size)){
		if(snpsused[i]){
			outfile <<line<<endl;
		}
		i++;
	}
	infile.close();
	outfile.close();
	// now .ped file

	infile.open(pedfile, ios::in);
	infile.clear();
	infile.seekg(0, ios::beg);
// print new .ped file
	outfile.open("ped.new", ios::out);
	while(infile.getline(line, size)){
		token = strtok(line, " ");
		outfile <<token;
		for(i = 1; i < nmf; i++){
			token = strtok(NULL, " ");
			outfile <<" "<<token;			
		}
		outfile <<"   ";
		for(i = 0; i < snpsinmapfile; i++){
			if(snpsused[i]){
				token = strtok(NULL, " ");
				outfile <<" "<<token;
				token = strtok(NULL, " ");
				outfile <<" "<<token;
			}
			else{
				token = strtok(NULL, " ");
				token = strtok(NULL, " ");
			}
		}
		outfile <<endl;
	}
	infile.close();
	outfile.close();
// print new gene_position_file
	/*
	FILE *fptrg = fopen("gene_pos.new","w");

	infile.open(gene_file_name, ios::in);
	infile.clear();
	infile.seekg(0, ios::beg);
	// first get an idea how many genes have one or more SNPs in them
	if (infile.is_open()){

		while(infile.getline(line, 1023)){
			genename = strtok(line, " ");
			token = strtok(NULL, " ");
			chrom = atoi(token);
			token = strtok(NULL, " ");
			start = atoi(token);
			token = strtok(NULL, " ");
			stop = atoi(token);
			position = findfirstsnp(chrom, start-buf, snpsinmapfile, snplist);
			if((position >= 0) && (snplist[position].position < (stop+buf))){
				fprintf(fptrg,"%s %i  %i  %i\n", genename, chrom, start, stop);
			}
		}
	}
	infile.close();
	fclose(fptrg);
*/
// print new s_index
	ifstream infile2;

	infile2.open(sindex_file, ios::in);
	infile2.clear();
	infile2.seekg(0, ios::beg);
	outfile.open("s_index.new", ios::out);
	i = 0;
	if (infile2.is_open()){
		while(infile2.getline(line, 1023)){
			if(genes_used[i]){
				outfile <<line<<endl;
			}
			i++;
		}
	}
	else{
		fprintf(stderr,"main::void print_new_map_ped. Can not open %s. Bailing out.\n", sindex_file);
		exit(0);
	}
	outfile.close();
	infile2.close();

	fprintf(stderr,"IMPOTANT!!!. I printed 4 new files: s_index.new, gene_pos.new, ped.new, map.new. \nThey replace: %s, %s, %s, %s. \nPlease change control file accordingly.\n",sindex_file, gene_file_name, pedfile, mapfile);
	delete [] line;
	exit(0);
}

//**********************************************
// list is sorted from small to large. Assumes the searched item is actually in the list!!!
// result: how many positions are less or equal then item
int findrank(float *list, int size, float item)
{
	int result = size+1;
	int lower = 0;
	int middle;
	int upper = size-1;
	if(size == 0){
		return(-1);
	}
	if(item < list[0]){
		return(-1);
	}
	if(item > list[upper]){
		return(-1);
	}
	while(lower <= upper){
		middle = (lower + upper) / 2;
		if(item == list[middle]){
			result = middle;
			break;
		}
		else if(item < list[middle]){
			upper = middle - 1;
		}
		else{
			lower = middle + 1;
		}
	}
	return(size-result);
}

//**********************************************
// finds values larger or equal to item

int largerequal(float *list, int size, float item)
{
	int result = -1;
	int lower = 0;
	int middle;
	int upper = size-1;
// first we need to take care of some borderline cases when item if less/equal smallest or bigger or equal largest
	if(size == 0) return(-1);
	if(item <= list[0]) return(size);
	if(item > list[upper]) return(0);
	if(item == list[upper]){
		while((item == list[upper]) && (upper > 0)){
			upper--;
			result++;
		}
		return(result);
	}
// At this point we know for sure that item is bigger than the smallest item and less than the largest item
	while(lower <= upper){
		middle = (lower + upper) / 2;
		if(item <= list[middle]){
			if(item > list[middle-1]){
				result = size - middle;
				break;
			}
			upper = middle - 1;
		}
		else{
			lower = middle + 1;
		}
	}

	return(result);
}

//**********************************************
/*
struct Fam{								// structure that holds the data
	int id;								// family identifier
	int members;						// each Family has 2 parents and "members - 2" children
	int loci;							// number of loci, kind of redundant since all Fams are going to have the same number
	unsigned char **geno;				// geno[i][j] is for the ith member and jth locus
										// geno[i][0] holds 0|1. 0 = not genotyped, 1 = valid data
										// geno[members][loci+6]
										// geno[i][1] = "individual ID"
										// geno[i][2] = "1st parent"
										// geno[i][3] = "2nd parent"
										// geno[i][4] = "male=1,female=2"
										// geno[i][5] = "aff.stat. aff=1,unaff=2,unkown=0"
										// geno[i][6+] = "upper 4 bits allele1, lower 4 bits allele2"

};

*/
struct Fam* delete_families(struct Fam *families, int famsize, int fams)
{
	int i,j; 
	for(i = 0;  i < fams; i++){
		for(j = 0; j < famsize; j++){
			delete [] families[i].geno[j];
		}
		delete [] families[i].geno;
	}
	delete [] families;
	return(NULL);
}

//**********************************************
